
#ifndef OFFSET_MAP_H
#define OFFSET_MAP_H

class OffsetMap
{
public:

    OffsetMap();

    ~OffsetMap();

    HRESULT Create(ID3D11Device* pd3dDevice, int length);

    void Release();

    int GetLength() const;

    HRESULT Set(ID3D11DeviceContext* pd3dImmediateContext, UINT iShaderSlot);

    enum 
    {
        kMapNone = 0x0,
        kMapVS = 0x1,
        kMapPS = 0x2,
        kMapGS = 0x4,
    };

    void SetMapMask(UINT mask) { m_MapMask = mask; }
    UINT GetMapMask() const { return m_MapMask; }

private:

    D3DXVECTOR2* const          GetRandomOffsets(int length) const;
    float                       Halton(int idx, int base) const;

    ID3D11Texture2D*            m_pTex;
    ID3D11ShaderResourceView*	m_pSRV;
    ID3D11SamplerState*         m_pSampler;

    UINT                        m_MapMask;
};

#endif // OFFSET_MAP_H
