

#include <windows.h>
#include <assert.h>
#include <d3d11.h>
#include <D3DX11.h>
#include <D3DX10math.h>

#include "Utility.h"
#include "TunableFV8Mgr.h"
#include "Cascade.h"
#include "BlitComposite.h"

// set the number of eccentricity layers. Must call Init() again after
void TunableFV8Mgr::SetNumLayers(int n)
{
    ISetNumLayers(n);
}
//
// set the size of an eccentricity layer
void TunableFV8Mgr::SetSize(int layer, int res)
{
    ISetSize(layer, res);
}
//
void TunableFV8Mgr::SetJitterScale(int layer, float jitter)
{
    ISetJitterScale(layer, jitter);
}

float TunableFV8Mgr::GetJitterScale( int layer ) const
{
    return IGetJitterScale(layer);
}
//
void TunableFV8Mgr::SetMSRead(int layer, bool b)
{
    ISetMSRead(layer, b);
}
//
void TunableFV8Mgr::SetFrameDecay(int layer, float f)
{
    ISetFrameDecay(layer, f);
}
float TunableFV8Mgr::GetFrameDecay( int layer )
{
    return IGetFrameDecay(layer);
}
//
void TunableFV8Mgr::SetRenderInterval(int layer, eRenderInterval e)
{
    ISetRenderInterval(layer, e);
}

TunableFV8Mgr::eRenderInterval TunableFV8Mgr::GetRenderInterval( int layer ) const
{
    return IGetRenderInterval(layer);
}

//
void TunableFV8Mgr::SetMSAA(int msaa)
{
    ISetMSAA(msaa);
}

void TunableFV8Mgr::SetMSAAInner(int b)
{
    ISetMSAAInner(b);
}
//
void TunableFV8Mgr::SetCompositeBlendStart(float f)
{
    ISetCompositeBlendStart(f);
}

float TunableFV8Mgr::GetCompositeBlendStart() const
{
    return IGetCompositeBlendStart();
}

void TunableFV8Mgr::SetRefreshSecs( int layer, float dSecs )
{
    ISetRefreshSecs(layer, dSecs);
}

float TunableFV8Mgr::GetRefreshSecs( int layer ) const
{
    return IGetRefreshSecs(layer);
}

Cascade* TunableFV8Mgr::GetCascade( int layer )
{
    return IGetCascade(layer);
}

void TunableFV8Mgr::SetDebugShowLevels( BlitComposite::ShowLevelMode mode, UINT mask )
{
    if(!mask)
        mode = BlitComposite::kShowNone;
    if((mode != GetDebugShowLevels()) || (mask != GetDebugShowLevelMask()))
    {
        BlitComposite::SetShowLevelMode(mode, mask);
        Release();
    }
}

BlitComposite::ShowLevelMode TunableFV8Mgr::GetDebugShowLevels() const
{
    return BlitComposite::GetShowLevelMode();
}

UINT TunableFV8Mgr::GetDebugShowLevelMask() const
{
    return BlitComposite::GetShowLevelMask();
}

int TunableFV8Mgr::GetMSAA() const
{
    return IGetMSAA();
}

int TunableFV8Mgr::GetMSAAInner() const
{
    return IGetMSAAInner();
}

void TunableFV8Mgr::SetUseMiddle( bool b )
{
    ISetUseMiddle(b);
}

bool TunableFV8Mgr::GetUseMiddle() const
{
    return IGetUseMiddle();
}

void TunableFV8Mgr::SetPerPixelJitter( float f )
{
    ISetPerPixelJitter(f);
}

float TunableFV8Mgr::GetPerPixelJitter() const
{
    return IGetPerPixelJitter();
}

