
#include <windows.h>
#include <d3d11.h>
#include <d3dx11.h>
#include <d3dcompiler.h>
#include <D3DX11.h>

#define _USE_MATH_DEFINES
#include <math.h>

#include <DXUT.h>

#include "Cylinder.h"

Cylinder::Cylinder()
{
	width = 1;
	length = 10;
}

HRESULT Cylinder::Init()
{
	return GridObject::Init();
}

void Cylinder::Cleanup()
{
	GridObject::Cleanup();

	SAFE_RELEASE(cylinderCB);
}

HRESULT Cylinder::GetConstantBuffers()
{
	HRESULT hr = S_OK;

	hr = GridObject::GetConstantBuffers();
    if( FAILED( hr ) )
        return hr;

    // Create the constant buffers
    D3D11_BUFFER_DESC bd;
    ZeroMemory( &bd, sizeof(bd) );
    bd.Usage = D3D11_USAGE_DEFAULT;
    bd.ByteWidth = sizeof(CylinderCB);
    bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
    bd.CPUAccessFlags = 0;

	ID3D11Device* pd3dDevice = DXUTGetD3D11Device();
    hr = pd3dDevice->CreateBuffer( &bd, NULL, &cylinderCB);
    if( FAILED( hr ) )
        return hr;

	return hr;
}

void Cylinder::UpdateConstants()
{
	GridObject::UpdateConstants();

    CylinderCB cb;

	cb.Size = D3DXVECTOR4(width, length, 0.0, 0.0);

	ID3D11DeviceContext* pImmediateContext = DXUTGetD3D11DeviceContext();
    pImmediateContext->UpdateSubresource( cylinderCB, 0, NULL, &cb, 0, 0 );

    pImmediateContext->VSSetConstantBuffers( 3, 1, &cylinderCB);
    pImmediateContext->PSSetConstantBuffers( 3, 1, &cylinderCB);
}

