
#ifndef CYLINDER_H
#define CYLINDER_H

#include "GridObject.h"

class Cylinder : public GridObject
{
private:
	ID3D11Buffer*			cylinderCB;
	float width;
	float length;

	struct CylinderCB
	{
		D3DXVECTOR4	Size;
	};

public:
	struct CylinderVertex
	{
		D3DXVECTOR2 Tex;
	};

	Cylinder();

	virtual HRESULT Init();
	virtual void Cleanup();

protected:
	virtual const WCHAR* ShaderFile() const { return L"Cylinder.fx"; }
	virtual const WCHAR* RefShaderFile() const { return L"CylinderRef.fx"; }
	virtual void UpdateConstants();
	virtual HRESULT GetConstantBuffers();

private:
};
#endif // CYLINDER_H
