
#ifndef LOD_OBJECT_H
#define LOD_OBJECT_H

#include "Object.h"
#include <vector>

class LODObject : public Object
{
public:
    LODObject();

	virtual ~LODObject();

	virtual HRESULT Init();
	virtual void OnResize();
	virtual void Cleanup();

	virtual int Render();

	virtual const D3DXMATRIX& GetLocalToWorld() const;
	virtual void SetLocalToWorld(const D3DXMATRIX& l2w);

    virtual void SetLocalBounds(const D3DXVECTOR3& lo, const D3DXVECTOR3& hi);
    virtual const Bounds& GetLocalBounds() const;
    virtual const Bounds& GetWorldBounds() const;

	virtual void IncrementTime(float fAdvanceTime);

    void SetLODObject(Object* obj, int lod);

    static int GetLOD()  { return currentLOD; }
    static void SetLOD(int lod) { currentLOD = max(0, lod); }
private:
    typedef std::vector<Object*> LODList;
    typedef LODList::iterator LODIter;
    typedef LODList::const_iterator LODConstIter;

    LODList lods;

    static int currentLOD;
    
    Object* GetCurrentObject() const;
};

#endif //LOD_OBJECT_H
