
#ifndef OBJECT_H
#define OBJECT_H

#include "../Utility/Bounds.h"

class Object
{
public:
	virtual ~Object() {}

	virtual HRESULT Init() = 0;
	virtual void OnResize() = 0;
	virtual void Cleanup() = 0;

	virtual int Render() = 0;

	virtual const D3DXMATRIX& GetLocalToWorld() const = 0;
	virtual void SetLocalToWorld(const D3DXMATRIX& l2w) = 0;

	virtual void IncrementTime(float fAdvanceTime) = 0;

public:

    virtual void SetLocalBounds(const D3DXVECTOR3& lo, const D3DXVECTOR3& hi) = 0;
    virtual const Bounds& GetLocalBounds() const = 0;
    virtual const Bounds& GetWorldBounds() const = 0;

};

#endif // OBJECT_H