
#ifndef PARAMETRIC_SURF_FX
#define PARAMETRIC_SURF_FX

#include "GridObject.h"

class ParametricSurface : public GridObject
{
private:
	const WCHAR* shaderFile;

	ID3D11Buffer*			materialCB;

	struct MaterialCB
	{
		D3DXVECTOR4 LightVector;
		D3DXVECTOR4 TessFactor;
	};

public:

	ParametricSurface();
	ParametricSurface(const WCHAR* shaderFile);

	virtual HRESULT Init();

	virtual void Cleanup();

protected:
	virtual const WCHAR* ShaderFile() const { return shaderFile; }
	virtual int ShaderModel() const { return 5; }
	virtual const CHAR* ShaderExtention() const { return "Grid"; }
	virtual const WCHAR* WideShaderExtention() const { return L"Grid"; }

	virtual void UpdateConstants();
	virtual HRESULT GetConstantBuffers();

	virtual D3DXVECTOR4 ModDivScale() const;

	virtual int NumU() const;
	virtual int NumV() const;

private:

};

#endif // PARAMETRIC_SURF_FX
