
#ifndef BLIT_QUAD_FX
#define BLIT_QUAD_FX

Texture2D<float4> tex : register( t0 );

sampler LinearSampler : register( s0 );
//{
//#if 0
	//Filter = MIN_MAG_MIP_POINT;
//#elif 0
    //MipFilter = LINEAR;
    //MinFilter = LINEAR;
    //MagFilter = LINEAR;
//#else
    //MipFilter = POINT;
    //MinFilter = POINT;
    //MagFilter = POINT;
//#endif
//};
//

cbuffer cbBlitQuad : register( b0 )
{
	float4 scaleOffSrc;
	float4 scaleOffDst;
    float4 tint;
};

struct VS_INPUT
{
	uint Index	: SV_VertexID;
};

struct PS_INPUT
{
	float4 Position : SV_POSITION;
	float2 TexCoord : TEXCOORD0;
};

PS_INPUT MakeVertex(uint vertId)
{
#if 0
	PS_INPUT output;
	output.Position = float4(
		(vertId % 2),
		(vertId / 2),
		0.5f,
		1.0f
		);
	output.TexCoord = output.Position.xy;

	output.Position.xy = output.Position.xy * scaleOffDst.xy + scaleOffDst.zw;

	output.TexCoord.xy = output.TexCoord.xy * scaleOffSrc.xy + scaleOffSrc.zw;

	return output;
#else
	PS_INPUT output;
	float2 domainPos = float2(
		(vertId % 2),
		(vertId / 2)
		);

	output.Position = float4(domainPos * scaleOffDst.xy + scaleOffDst.zw, 0.0f, 1.0f);

	output.TexCoord.xy = domainPos * scaleOffSrc.xy + scaleOffSrc.zw;

	return output;
#endif
}
PS_INPUT VS_Def(VS_INPUT input)
{
	PS_INPUT output = MakeVertex(input.Index);

	return output;
}
PS_INPUT VS_Flat(VS_INPUT input)
{
	PS_INPUT output = MakeVertex(input.Index);

	return output;
}

float4 PS_Def(PS_INPUT input) : SV_Target
{
//	return float4(1.0f, 0.5f, 0.5f, 1.0f);

	return tex.Sample( LinearSampler, input.TexCoord ) * tint;
}
float4 PS_Flat(PS_INPUT input) : SV_Target
{
//    return float4(1.0f, 0.0f, 0.0f, 1.0f);

	return tint;
}

#endif // BLIT_QUAD_FX
