
#ifndef BASE_BUFFERS_H
#define BASE_BUFFERS_H

TextureCube <float4> cubeMap : register( t0 );
SamplerState cubeSampler : register( s0 );

SamplerState sampleClamp
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};


//--------------------------------------------------------------------------------------
// Constant Buffer Variables
//--------------------------------------------------------------------------------------
cbuffer cbChangesEveryFrame : register( b9 )
{
    matrix CameraToNDC;

	float4 DetailParams; // for procedural texture antialiasing, .zw currently contains redundant windowsize.xy. .y unused.

	float4 WindowSize; // reprojection, only .w currently used, which is blend factor. .xy is windowsize. .z is depth tolerance

	float4 Light;

    matrix WorldToCamera;
};

cbuffer cbChangesEveryObject : register( b1 )
{
    matrix LocalToWorld;

	float4 ModDivScale;

	matrix LastLocalToNDC;

	float4 WorldCamPos;
};

#endif // BASE_BUFFERS_H
