
#ifndef NORMALIZE_CHECK_FX
#define NORMALIZE_CHECK_FX

float2 NormalizeCheckedZero(const float2 vec)
{
	float len = dot(vec, vec);

	return len > 0 ? vec * rsqrt(len) : float2(0, 0);
}

float3 NormalizeCheckedZero(const float3 vec)
{
	float len = dot(vec, vec);

	return len > 0 ? vec * rsqrt(len) : float3(0, 0, 0);
}

float2 NormalizeCheckedUnitY(const float2 vec)
{
	float len = dot(vec, vec);

	return len > 0 ? vec * rsqrt(len) : float2(0.0f, 1.0f);
}

float3 NormalizeCheckedUnitY(const float3 vec)
{
	float len = dot(vec, vec);

	return len > 0 ? vec * rsqrt(len) : float3(0.0f, 1.0f, 0.0f);
}

//#define NORMALIZE_CHECK(v) NormalizeCheckedZero( v )
#define NORMALIZE_CHECK(v) NormalizeCheckedUnitY( v )


#endif // NORMALIZE_CHECK_FX
