
#ifndef POINT_LIGHT_FX
#define POINT_LIGHT_FX

#include "BaseShader.fx"

float3 PointLight(
	float3 position, 
	float3 normal,
	float3 camPos)
{
	float3 lightPos = float3(0.0f, 9.0f, 10.0f);

	float3 lightVec = lightPos - position;

	float len = length(lightVec);
	float atten = 1.0f - saturate(len * Light.w);
	lightVec /= len;

	float NdotL = saturate(dot(lightVec, normal));
	NdotL *= Light.x;

	lightVec = reflect(-lightVec, normal);

	float spec = saturate(dot(NORMALIZE_CHECK(camPos.xyz - position.xyz), lightVec));
	spec = pow(spec, Light.z);
	spec *= Light.y;

	float3 color = lerp(float3(0.1, 0.1, 0.2), float3(1.0, 0.8, 0.8), NdotL * atten);

	color += spec.xxx * atten;
//color = spec.xxx * atten;

	return color;
}

#endif //  POINT_LIGHT_FX
