
//------------------------------------
// Autogenerated shader file
//------------------------------------

// Define for any special procedural surface path (default none).

#define MAF_APPLY_NONE

//------------------------------------

// Define surface properties for this model
#define MATERIAL_FROM_FX
static const float4 MaterialColor = float4(1, 0.77, 0.5, 1.0);
static const float AmbientFactor = 0.05;
static const float DiffuseFactor = 0.9;
static const float SpecularFactor = 2;
static const float SpecularPower = 16;
static const float Reflectivity = 0.1;

// AABB( D3DXVECTOR3( -0.3f, -0.3f, -0.8f), D3DXVECTOR3( 0.3f, 0.3f, 0.5f)))

//------------------------------------
// Control points defining the curves come next.

// First Curve
//------------------------------------
// List of control points

struct controlPoints_U_array
{
	float2 array[ 26 ];
};
static const controlPoints_U_array controlPoints_U = {
	{ 0.0, 370.0 },
	{ 0.0, 370.0 },
	{ 0.0, 370.0 },
	{ 60.0, 370.0 },
	{ 60.0, 370.0 },
	{ 60.0, 370.0 },
	{ 50.0, 330.0 },
	{ 50.0, 330.0 },
	{ 50.0, 330.0 },
	{ 80.0, 320.0 },
	{ 50.0, 310.0 },
	{ 50.0, 310.0 },
	{ 50.0, 310.0 },
	{ 70.0, 290.0 },
	{ 30.0, 200.0 },
	{ 30.0, 200.0 },
	{ 30.0, 200.0 },
	{ 50.0, 190.0 },
	{ 30.0, 180.0 },
	{ 30.0, 180.0 },
	{ 30.0, 180.0 },
	{ 60.0, 140.0 },
	{ 20.0, 100.0 },
	{ 0.0, 50.0 },
	{ 0.0, 50.0 },
	{ 0.0, 50.0 }
};
static const float controlPointCount_U = controlPoints_U.array.Length;

//------------------------------------
// Now set defines to this set of control points and
// include the BSpline evaluation code to compile a function
// to evaluate this specific set of control points.
// See comments in BSpline.fx for why we do this.
//------------------------------------

#define FUNC_LABEL BSpline_Evaluate_FuncU
#define CONTROL_POINTS controlPoints_U.array
#define CONTROL_POINT_COUNT	controlPointCount_U

#include "BSpline.fx"

// Now unset the defines to return to original state
#undef FUNC_LABEL
#undef CONTROL_POINTS
#undef CONTROL_POINT_COUNT
//------------------------------------

// We only have one curve (e.g. surface of revolution)
// we write out our single curve twice. Second curve is
// ignored, but it keeps the compiler happy.
//------------------------------------
// List of control points

struct controlPoints_V_array
{
	float2 array[ 26 ];
};
static const controlPoints_V_array controlPoints_V = {
	{ 0.0, 370.0 },
	{ 0.0, 370.0 },
	{ 0.0, 370.0 },
	{ 60.0, 370.0 },
	{ 60.0, 370.0 },
	{ 60.0, 370.0 },
	{ 50.0, 330.0 },
	{ 50.0, 330.0 },
	{ 50.0, 330.0 },
	{ 80.0, 320.0 },
	{ 50.0, 310.0 },
	{ 50.0, 310.0 },
	{ 50.0, 310.0 },
	{ 70.0, 290.0 },
	{ 30.0, 200.0 },
	{ 30.0, 200.0 },
	{ 30.0, 200.0 },
	{ 50.0, 190.0 },
	{ 30.0, 180.0 },
	{ 30.0, 180.0 },
	{ 30.0, 180.0 },
	{ 60.0, 140.0 },
	{ 20.0, 100.0 },
	{ 0.0, 50.0 },
	{ 0.0, 50.0 },
	{ 0.0, 50.0 }
};
static const float controlPointCount_V = controlPoints_V.array.Length;

//------------------------------------
// Now set defines to this set of control points and
// include the BSpline evaluation code to compile a function
// to evaluate this specific set of control points.
// See comments in BSpline.fx for why we do this.
//------------------------------------

#define FUNC_LABEL BSpline_Evaluate_FuncV
#define CONTROL_POINTS controlPoints_V.array
#define CONTROL_POINT_COUNT	controlPointCount_V

#include "BSpline.fx"

// Now unset the defines to return to original state
#undef FUNC_LABEL
#undef CONTROL_POINTS
#undef CONTROL_POINT_COUNT
//------------------------------------

#include "Parametric3DGrid.fx"

//------------------------------------
// VS_Grid() and PS_Grid() are always external vertex and
// pixel shaders resp. for the uniform grid.
// They pass through to the appropriate surface type below
//------------------------------------

PS_INPUT_HARDWARE VS_Grid( const VSHARDWARE_INPUT input )
{
	return VS_Hardware_SurfaceOfRevolution(input);
}

float4 PS_Grid( const PS_INPUT_HARDWARE input ) : SV_Target
{
	return PS_Hardware_SurfaceOfRevolution(input);
}
//------------------------------------
// For the dynamically tessellated version, we always use
// the same pass-thru vertex shader. Also, the we always
// use the same pass-thru hull shader, and the same hull
// constant shader for tessellation factors.
// Vertex shader is always VS_Patch(), hull shader is
// always HS_Patch(), and hull constant shader is HS_PatchConstant()
// Also, the pixel shader is identical to the pixel shader
// for the uniform grid, so PS_Patch() just calls PS_Grid(),
// which has already been defined appropriately above.
// That just leaves the domain shader. As above, the app
// always calls DS_Patch(), which passes through to the
// correct version for this surface type.
//------------------------------------

#include "Parametric3DPatch.fx"

[domain("quad")]
PS_INPUT_HARDWARE DS_Patch(	HS_CONSTANT_DATA_OUTPUT input, 
		float2 UV : SV_DomainLocation,
		const OutputPatch<HS_OUTPUT, OUTPUT_PATCH_SIZE> patch )
{
	return DS_SurfaceOfRevolution( input, UV, patch );
}

