
#ifndef CAMERA_MODE_H
#define CAMERA_MODE_H

class CFlyCamera;

class CameraMode
{
public:
    CameraMode() {}

    virtual ~CameraMode() {}

    virtual void Init(const CFlyCamera& camera) = 0;

    virtual void Reset() = 0;

    virtual void Advance(const CFlyCamera& camera, const FLOAT fSecs) = 0;

    virtual D3DXVECTOR3 GetEyePt() const = 0;
    virtual D3DXVECTOR3 GetLookAtPt() const = 0;
    virtual D3DXVECTOR3 GetUpDir() const = 0;

    // Logging stuff.
    enum LogMode
    {
        kLogNone,
        kLogBuild,
        kLogFrom
    };
    virtual LogMode GetLogMode() const = 0;

    virtual bool BeginBuildLog() = 0;
    virtual bool EndBuildLog(const WCHAR* const fileName) = 0;
    virtual bool BeginFromLog(const WCHAR* const fileName) = 0;
    virtual bool EndFromLog() = 0;

    virtual void SetSpeedGoal(float f) = 0;
    virtual float GetSpeedGoal() const = 0;
};

#endif // CAMERA_MODE_H
