
#include <assert.h>
#include <D3DX10math.h>

#include "../FauxV8Kit/Utility.h"

#include "CameraModeSelect.h"
#include "CameraDrive.h"
#include "CameraWalk.h"
#include "CameraCircle.h"
#include "CameraRandom.h"
#include "CameraPan.h"

CameraMode* CameraModeSelect::Create(eCameraModes mode)
    {
        switch(mode)
        {
        case kCircle:
            return new CameraCircle();

        case kWalk:
            return new CameraWalk();

        case kDrive:
            return new CameraDrive();

        case kRandom:
            return new CameraRandom();

        case kPan:
            return new CameraPan();

        default:
            break;
        }

        assert(false); // unknown camera mode
        return new CameraDrive();
    }

const WCHAR* CameraModeSelect::Name(eCameraModes mode)
    {
        switch(mode)
        {
        case kCircle:
            return L"Circle";
        case kWalk:
            return L"Walk";
        case kDrive:
            return L"Drive";
        case kRandom:
            return L"Random";
        case kPan:
            return L"Pan";

        default:
            break;
        }

        assert(false);
        return L"Uknown";
    }

CameraMode* CameraModeSelect::Delete(CameraMode* mode)
{
    SAFE_DELETE(mode);
    return NULL;
}
