
#ifndef CAMERA_RANDOM_H
#define CAMERA_RANDOM_H

#include "CameraDrive.h"
#include "Accelerator.h"

class CameraRandom : public CameraDrive
{
public:
    CameraRandom();

    virtual void Advance( const CFlyCamera& camera, const FLOAT fSecs );

protected:

    virtual VOID CheckTravelDirection( const D3DXVECTOR3& eyePt, const FLOAT fSecs );

    virtual D3DXVECTOR3 GetTravelDirection( const D3DXVECTOR3& eye, const D3DXVECTOR3& lookAt ) const;

    virtual BOOL NeedNewDirection( const FLOAT fSecs );
    virtual FLOAT TimeTillTurn() const { return timeTillTurn; }
    virtual FLOAT NewDirection( const D3DXVECTOR3& eyePt);
    
    BOOL OutGoing( const D3DXVECTOR3& eyePt ) const;
    void SetAccel();
protected:
    FLOAT currYaw;

    FLOAT secsOfTravel;
    FLOAT timeTillTurn;

    AcceleratorYaw m_YawAccel;
    Accelerator m_HeightAccel;
    Accelerator m_LookAtAccel;
};

#endif // CAMERA_RANDOM_H
