
#ifndef CAMERA_WALK_H
#define CAMERA_WALK_H

#include "CameraDrive.h"
#include "Accelerator.h"

class CameraWalk : public CameraDrive
{
public:
    CameraWalk();

    virtual void Advance(const CFlyCamera& camera, const FLOAT fSecs);

protected:

    virtual D3DXVECTOR3 GetTravelDirection(const D3DXVECTOR3& eye, const D3DXVECTOR3& lookAt) const;

    virtual void SetHeightAccel();

    Accelerator m_HeightAccel;
    Accelerator m_LookAtAccel;
};

#endif // CAMERA_WALK_H
