
#ifndef COMPILE_SHADER_H
#define COMPILE_SHADER_H

class CompiledShader
{
private:
	SIZE_T		byteCodeLength;
	void*		byteCodes;

	CompiledShader()
		:	byteCodeLength(0),
			byteCodes(NULL)
	{
	}
	CompiledShader(const CompiledShader& eff)
		:	byteCodeLength(eff.byteCodeLength)
	{
		byteCodes = new char[byteCodeLength];
		memcpy_s(byteCodes, byteCodeLength, eff.byteCodes, eff.byteCodeLength);
	}

	void Release()
	{
		if(byteCodes)
		{
			delete [] byteCodes;
			byteCodes = NULL;
			byteCodeLength = 0;
		}
	}

public:

	CompiledShader(const WCHAR* fileName,
					const WCHAR* profile,
					const WCHAR* entryPoint);

	~CompiledShader();

	SIZE_T GetBufferSize() const { return byteCodeLength; }
	void* GetBufferPointer() const { return byteCodes; }
};


#endif // COMPILE_SHADER_H
