
#ifndef FILE_DATE_CHECK_H
#define FILE_DATE_CHECK_H

#include <vector>

class FileDateCheck
{

public:

	FileDateCheck();
	FileDateCheck(const WCHAR* srcFile, const WCHAR* dstFile);

	virtual ~FileDateCheck();

	bool OutOfDate() const { return outOfDate; }

	bool Check(const WCHAR* srcFile, const WCHAR* dstFile);

protected:
	
	void SetFolder(const WCHAR* srcFile);

	const WCHAR* Folder() const { return folder; }

	bool AlreadyDependent(const WCHAR* depName) const;
	void GetDependencies(const WCHAR* srcFile);

	void CheckDependencies(const WCHAR* dstFile);

	void ClearDependencies();

	bool GetTimeStamp(const WCHAR* fileName, FILETIME& fileTime) const;
	bool ExtractIncludeName(const WCHAR* lineBuff, WCHAR* nameBuff) const;
private:
	bool outOfDate;

	WCHAR folder[MAX_PATH];

	typedef std::vector<WCHAR*>	NameList;
	typedef NameList::iterator	NameIter;
	typedef NameList::const_iterator NameConstIter;

	NameList	dependencies;
};

#endif // FILE_DATE_CHECK_H
