
#ifndef BLIT_DEPTH_H
#define BLIT_DEPTH_H

#include "BlitQuad.h"

class BlitDepth : public BlitQuad
{
public:
    void SetRadiusSquared(float rSq) { m_fRadiusSq = rSq; }
    float GetRadiusSquared() const { return m_fRadiusSq; }

    XMFLOAT2 GetCenter() const { return XMFLOAT2(m_Center.x, m_Center.y); }
    void SetCenter(const XMFLOAT2& center) { m_Center.x = center.x; m_Center.y = center.y; }

    XMFLOAT2 GetSize() const { return XMFLOAT2(m_Center.z, m_Center.w); }
    void SetSize(const XMFLOAT2& size) { m_Center.z = size.x; m_Center.w = size.y; }
protected:

    virtual void SetConstants(ID3D11DeviceContext* immediateContext, ID3D11ShaderResourceView* baseTex);
    virtual HRESULT InitConstantBuffers(ID3D11Device* pd3dDevice);
    virtual HRESULT InitState(ID3D11Device* pd3dDevice);

    float   m_fRadiusSq;
    XMFLOAT4 m_Center;
};
#endif BLIT_DEPTH_H