
#ifndef MOUSE_POS_STRUCT_H
#define MOUSE_POS_STRUCT_H

struct MousePosStruct
{
    struct Pos3D
    {
        float x;
        float y;
        float z;
    };

    long valid;
    long timeStamp_Secs;
    long timeStamp_uSecs;
    float posX;
    float posY;
    long delay_uSecs;
    long logging;

    long leftEyeValid;
    Pos3D  leftEyePos;

    long rightEyeValid;
    Pos3D rightEyePos;

    Pos3D midEyePos;

    bool Valid() const { return valid != 0; }
    double Seconds() const { return double(timeStamp_Secs) + double(timeStamp_uSecs) * 1.0e-6; }
    double MilliSeconds() const { return double(timeStamp_Secs) * 1.0e3 + double(timeStamp_uSecs) * 1.0e-3; }
    double MicroSeconds() const { return double(timeStamp_Secs) * 1.0e6 + double(timeStamp_uSecs); }
};

#endif // MOUSE_POS_STRUCT_H
