
#ifndef OFFSCREEN_RT_H
#define OFFSCREEN_RT_H

#include "SaveRenderState.h"

class OffscreenRT
{
public:

	OffscreenRT();

	~OffscreenRT();

    HRESULT Create(ID3D11Device* pd3dDevice, int width, int height, int msaa);

	void Release();

	void Push(ID3D11DeviceContext* pd3dImmediateContext);

	void Clear(ID3D11DeviceContext* pd3dImmediateContext, const float* const color);

	void Pop(ID3D11DeviceContext* pd3dImmediateContext);

	ID3D11ShaderResourceView* RTShaderResource() { return m_pRTResourceView; }
    ID3D11ShaderResourceView* DSShaderResource() { return m_pDSResourceView; }

	int GetWidth() const { return m_iWidth; }
	int GetHeight() const { return m_iHeight; }

    HRESULT Save(const WCHAR* fileName, ID3D11Device* pd3dDevice, ID3D11DeviceContext* pd3dImmediateContext);
private:

	SaveRenderState             m_SaveState;

	int m_iWidth;
	int m_iHeight;

	ID3D11Texture2D*			m_pRT;
	ID3D11RenderTargetView*		m_pRTV;
	ID3D11Texture2D*			m_pDS;
	ID3D11DepthStencilView*		m_pDSV;

    ID3D11Texture2D*            m_pDSTex;
    ID3D11ShaderResourceView*   m_pDSResourceView;

    ID3D11Texture2D*            m_pTex;
	ID3D11ShaderResourceView*	m_pRTResourceView;
};


#endif //  OFFSCREEN_RT_H
