
#ifndef TUNABLE_FV8_MGR_H
#define TUNABLE_FV8_MGR_H

#include "FauxV8Mgr.h"
#include "BlitComposite.h"

class TunableFV8Mgr : public FauxV8Mgr
{
public:

    // set the number of eccentricity layers. Must call Init() again after
    void SetNumLayers(int n);
    //
    // set the size of an eccentricity layer
    void SetSize(int layer, int res);
    int GetSize(int layer) const { return IGetSize(layer); }
    //
    void SetJitterScale(int layer, float jitter);
    float GetJitterScale(int layer) const;
    //
    void SetMSRead(int layer, bool b);
    bool GetMSRead(int layer) const { return IGetMSRead(layer); }
    //
    void SetFrameDecay(int layer, float f);
    float GetFrameDecay(int layer);
    //
    void SetRenderInterval(int layer, eRenderInterval e);
    eRenderInterval GetRenderInterval(int layer) const;

    void SetRefreshSecs(int layer, float dSecs);
    float GetRefreshSecs(int layer) const;
    //
    void SetMSAA(int msaa);
    int GetMSAA() const;

    void SetMSAAInner(int b);
    int GetMSAAInner() const;

    void SetUseMiddle(bool b);
    bool GetUseMiddle() const;
    //
    void SetCompositeBlendStart(float f);
    float GetCompositeBlendStart() const;

    void SetDebugShowLevels(BlitComposite::ShowLevelMode mode, UINT mask = 0xff);
    BlitComposite::ShowLevelMode GetDebugShowLevels() const;
    UINT GetDebugShowLevelMask() const;


    ////////////////////////////////////////////////////////////

    //////////////////////////////////////////////////////////////////////////
    // Really under the hood stuff exposed here.
    Cascade* GetCascade(int layer);
};
#endif // TUNABLE_FV8_MGR_H